# -*- coding: utf-8 -*-

from PyQt4.QtSql import *

class ConexionPgSQL():
    """ Provee los mtodos para conectarse a PostgreSQL/PostGIS """

    def __init__(self, servidor, puerto, bd, usuario, contrasena):

        if QSqlDatabase.contains("midb"):
            QSqlDatabase.removeDatabase("midb") # Uso del mtodo esttico

        # Paramentros conexion
        self.db = QSqlDatabase.addDatabase("QPSQL", "midb")
        self.db.setHostName(servidor)
        self.db.setPort(int(puerto))
        self.db.setDatabaseName(bd)
        self.db.setUserName(usuario)
        self.db.setPassword(contrasena)

        self.query = QSqlQuery(self.db) # Inicializar objeto query

    def conectar(self):
        """ Abre la conexin a la base de datos """
        ok = self.db.open()
        return ok

    def consultarCapas(self):
        """ Retorna un arreglo de datos con la informacin de la tabla
            geometry_columns de PostGIS """
        if self.query.exec_("SELECT f_table_schema, f_table_name, " +
            "f_geometry_column, type FROM public.geometry_columns"):
            record = self.query.record()
            posEsquema = record.indexOf("f_table_schema")
            posTabla = record.indexOf("f_table_name")
            posGeom = record.indexOf("f_geometry_column")
            posType = record.indexOf("type")

            aTabla = []

            while self.query.next(): # Leer los datos de la consulta
                esquema = self.query.value(posEsquema).toString()
                tabla = self.query.value(posTabla).toString()
                geom = self.query.value(posGeom).toString()
                tipo = self.query.value(posType).toString()

                aDatos = [esquema, tabla, geom, tipo]
                aTabla.append(aDatos)

            return aTabla

        else:
            return None
